REM 2005 (c) Copyright IBM Corp.
REM All Rights Reserved.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				  2005 (c) Copyright IBM Corp
:: 					All Rights Reserved
::   
:: OVERVIEW:
::   
:: Siebel-specific installation.
:: 
:: USAGE  script <parent dir for FunctionalTester>
:: 
:: AUTHOR:  Christopher Maguire
::   
:: DATE			COMMENT
:: 2005.11.07	Initial version of script.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::



@ECHO ON
@CALL :LogHeader Start %0
@CALL :SetGlobals %0 %1

@CALL :Main

@CALL :LogHeader End %0
GOTO :EOF

:SetGlobals
	SET PROD_INSTALL=%2
	SET RFTPlugins=%PROD_INSTALL%\FunctionalTester\eclipse\plugins
	SET WSW=%RFTPlugins%\com.rational.test.ft.wswplugin_6.1.0
	SET SIEBEL_DIR=%PROD_INSTALL%\FunctionalTester\Siebel
	SET ERR_CODE=0
	SET result=""
	SET msdnhelpfolder=%PROD_INSTALL%\FunctionalTester\MSDNHelp
	SET backup=%PROD_INSTALL%\FunctionalTester\eclipse\plugins\backup\rft61_fixpack\updater.rft_specific.win32.install
	@GOTO :EOF

:Main
	CALL :CheckGacUtility
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :InstallSiebel
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	@GOTO :EOF

:LogHeader
	@echo "---------------- %1 %2 -----------------"
	@Date /T
	@Time /T
	@echo "Current Directory:"
	cd
	@GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Install Siebel
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallSiebel
	CALL :CheckCustomInstaller
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :SetCustDir
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :AllowScriptRerun
	CALL :CheckForDotNetFramework
	@if not %ERR_CODE% == 0 (
		@SET ERR_CODE=0
		CALL :SetCustDir
		CALL :FixPartialSiebelInstall
		@GOTO :EOF
	)
	CALL :SetCustDir
	CALL :CopyToCustDir %SIEBEL_DIR% rational_ft_siebel.jar
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% rational_ft_siebel.rftcust
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% Interop.cascomlib.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% Interop.Shdocvw.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% Interop.mshtml.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% SiebelDomainProxies.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% SiebelIEHelper.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :CopyToCustDir %SIEBEL_DIR% SiebelNotificationListener.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF

	CALL :GACInCustDir Interop.cascomlib.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :GACInCustDir Interop.Shdocvw.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :GACInCustDir Interop.mshtml.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :GACInCustDir SiebelDomainProxies.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :GACInCustDir SiebelIEHelper.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :GACInCustDir SiebelNotificationListener.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF

	CALL :RegasmInCustDir SiebelDomainProxies.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :RegasmInCustDir SiebelIEHelper.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :RegasmInCustDir SiebelNotificationListener.dll
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	CALL :ImportRegistryFile %SIEBEL_DIR% siebel_defaultapplicationname.reg
																			@if not %ERR_CODE% == 0 @GOTO :EOF
	SET VSNET_2005_Present=0
	CALL :CheckForVSNetVersion 8.0
	CALL :CorrectConfigLocation
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Fix Partial Siebel Install
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:FixPartialSiebelInstall
	@if not %custDir% == "" (
		@echo "BEGIN Fixing Partial Siebel Install"
		@echo "Removing all Siebel files from %custDir% and then replacing rational_ft_siebel.jar"
		@echo "Contents of %custDir% BEFORE actions taken:"
		@DIR %custDir%\*siebel*
		DEL /F /Q %custDir%\*siebel*
		CALL :CopyToCustDir %SIEBEL_DIR% rational_ft_siebel.jar
		@echo "Contents of %custDir% AFTER actions taken:"
		@DIR %custDir%\*siebel*
		@echo "DONE Fixing Partial Siebel Install"
	) else (
		@echo "Unable to fix Partial Siebel Install problem due to inability to compute Customization Dir"
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Set Cust Dir
:: custDir will have double quotes around it.  If we can't find it, it will be "".
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetCustDir
	@echo "=== Attempting to compute customization directory"
	@SET defaultCustDir="C:\Documents and Settings\All Users\Application Data\IBM\RFT\customization"
	@SET custDir=
	@SET REG_QUERY=rreg.exe query "hklm\SOFTWARE\Rational Software\Rational Test\8" /v "Rational FT Customization Directory"
	@for /f "tokens=5*" %%i in ('%REG_QUERY%') do @SET custDir=%%j
	@SET custDir="%custDir%"
	@if EXIST %custDir% (
		@echo "=== Computed custDir using rreg.exe"
		@echo "=== custDir set to %custDir%"
		@GOTO :EOF
	) else (
		@echo "=== Failed to computed custDir using rreg.exe"
	)
	@SET custDir=%defaultCustDir%
	@if EXIST %custDir% (
		@echo "=== Will use default value for custDir"
		@echo "=== custDir set to %custDir%"
		@GOTO :EOF
	) else (
		@echo "=== Default custDir %custDir% does not exist"
	)
	@echo "=== Computing customization directory failed"
	@SET ERR_CODE=1
	@SET custDir=""
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Check GacUtility
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckGacUtility
	CALL :CheckFileExistance gacutility.exe
	@if %ERR_CODE%==1 (
		SET result=Gacutility not found
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                     Copy to Customization Directory
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CopyToCustDir
	@SET	ERR_CODE=0

	CALL :CheckFileExistance %1\%2
	@IF %ERR_CODE%==1 @GOTO :EOF

	copy /Y %1\%2 %custDir%\%2
	@IF	%ERRORLEVEL% == 1 (
		@ECHO Unable to copy to %custDir%\%2
		SET ERR_CODE = 1
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                     Run GAC Utility in Customization Directory
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GACInCustDir
	@SET	ERR_CODE=0
	@SET gacThis= %custDir%\%1
	@CALL :CheckFileExistance %gacThis%
	@IF %ERR_CODE%==1 @GOTO :EOF

	gacutility.exe -a %gacThis% -o
	@IF %ERRORLEVEL% == 0 ( 
		@echo "GACUtility.exe succeeded"
	) else (
		@SET ERR_CODE=1
		@echo "GACUtility.exe Error"
	)
	@GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Regasm in Customization Directory
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:RegasmInCustDir
	@SET	ERR_CODE=0
	@SET regThis=%custDir%\%1

	CALL :CheckFileExistance %regThis% QUIET
	@IF %ERR_CODE%==1 (
		@ECHO Can't run regasm on non existent file:  %regThis%
		@GOTO :EOF
	)

	PUSHD %custDir%
	@ECHO %regasm% %1
	%regasm% %1
	@IF	%ERRORLEVEL% == 1 (
		@ECHO ERROR: regasm failed
		SET ERR_CODE = 1
	)
	POPD
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Install Custom File
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallCustomFile
	@SET	ERR_CODE=0

	CALL :CheckFileExistance %2\%3
	@IF %ERR_CODE%==1 @GOTO :EOF

	copy %2\%3 %3
	InstallCustomFile.exe %1 %3
	@IF	%ERRORLEVEL% == 0 (
		@SET ERR_CODE=0
		@GOTO	:EOF
	) else (
		@IF ERRORLEVEL 1  SET result=ErrorCode 1 : Invalid number of arguments for custom installer
		@IF ERRORLEVEL 2  SET result=ErrorCode 2 : Custom File Not Found
		@IF ERRORLEVEL 3  SET result=ErrorCode 3 : Custom Folder Not Found
		@IF ERRORLEVEL 4  SET result=ErrorCode 4 : Custom Install Command Timed Out
		@IF ERRORLEVEL 5  SET result=ErrorCode 5 : Command File Create failure (5)
		@IF ERRORLEVEL 6  SET result=ErrorCode 6 : Command File Create failure (6)
		@SET ERR_CODE=1
	)
	@GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				           Check For Custom Installer 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckCustomInstaller
	CALL :CheckFileExistance InstallCustomFile.exe

	@IF %ERR_CODE%==1 (
		SET	result=Custom file installer Not Found
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Check For DotNet Frame Work 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckForDotNetFramework
	@SET regasm1_1=%windir%\Microsoft.NET\Framework\v1.1.4322\regasm.exe
	@SET regasm2_0=%windir%\Microsoft.NET\Framework\v2.0.50727\regasm.exe

	@CALL :CheckFileExistance %regasm2_0% QUIET
	@IF %ERR_CODE%==0 (
		@SET regasm=%regasm2_0%
		@echo "Found .Net Framework 2.0"
		@GOTO :EOF
	)

	@CALL :CheckFileExistance %regasm1_1% QUIET
	@IF %ERR_CODE%==0 (
		@SET regasm=%regasm1_1%
		@echo "Found .Net Framework 1.1"
		@GOTO :EOF
	)
	@echo "Could not find .Net Framework 2.0: %regasm2_0%"
	@echo "Could not find .Net Framework 1.1: %regasm1_1%"
	@echo "No .Net Framework found"
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Check For VS Net Versions
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckForVSNetVersion
	@set ver=%1
	@set KEY=HKLM\SOFTWARE\Microsoft\VisualStudio\%ver%
	@set VALUE=InstallDir
    @set REG_QUERY=rreg.exe query %KEY%
    @set errorlevel=
    @%REG_QUERY% /v %VALUE%
    @if errorlevel 1 (
		@GOTO :EOF
	)
    @set dir=
    @for /f "tokens=2*" %%i in ('%REG_QUERY% /v %VALUE%') do @set dir=%%j
    @if "%dir%" == "" (
		@echo No data for value %VALUE% for key %KEY%
		@GOTO :EOF
	)
	@CALL :CheckFileExistance "%dir%devenv.exe"
	@if not %ERR_CODE% == 0 (
		@GOTO :EOF
	)
	@if %ver% == 7.1 (
		SET VSNET_2003_Present=1
	)
	@if %ver% == 8.0 (
		SET VSNET_2005_Present=1
	)
    @GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Config files should only be in wsw plugin's top folder if VS Net 2005 is installed
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CorrectConfigLocation
	@if %VSNET_2005_Present% == 0 (
		@ECHO --- VS Net 2005 NOT installed.
		@ECHO --- Hiding config files if necessary...
		@IF not EXIST %WSW%\configs (
			mkdir %WSW%\configs
		)
		CALL :MoveIfFromExists %WSW%\rational_ft.exe.config  %WSW%\configs\rational_ft.exe.config
		CALL :MoveIfFromExists %WSW%\rational_ftw.exe.config %WSW%\configs\rational_ftw.exe.config
		@ECHO --- Done hiding config files.
	) else (
		@ECHO --- VS Net 2005 installed.
		@ECHO --- Unhiding config files if necessary...
		CALL :MoveIfToDoesNotExist %WSW%\configs\rational_ft.exe.config  %WSW%\rational_ft.exe.config
		CALL :MoveIfToDoesNotExist %WSW%\configs\rational_ftw.exe.config %WSW%\rational_ftw.exe.config
		@ECHO --- Done unhiding config files.
	)
	@GOTO :EOF

:MoveIfFromExists
	@SET from=%1
	@SET to=%2
	@if EXIST %from% (
		move /Y %from% %to%
	) else (
		@ECHO No need to hide %from%
	)
	GOTO :EOF

:MoveIfToDoesNotExist
	@SET from=%1
	@SET to=%2
	@if not EXIST %to% (
		move /Y %from% %to%
	) else (
		@ECHO No need to unhide %to%
	)
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                    Import Registry File
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ImportRegistryFile
	@SET	ERR_CODE=0
	@CALL :CheckFileExistance %1\%2
	@IF %ERR_CODE%==1 @GOTO :EOF

	PUSHD %1
	RegEdit	/s %2
	@IF ERRORLEVEL 1 (
		@SET ERR_CODE=1
		SET result=Failed to Import Registry File %1\%2
	)
	POPD
	@GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                         Check For a file existance
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckFileExistance
	@SET ERR_CODE=0
	@IF not EXIST %1 (
		SET ERR_CODE=1
		@IF "%2" == "QUIET" @GOTO :EOF
		echo ERROR:  Could not find %1
	)
	@GOTO :EOF 

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Allow Script Rerun
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:AllowScriptRerun
	CALL :CheckFileExistance %SIEBEL_DIR%\rerun_installSiebel.bat QUIET
	@if not %ERR_CODE% == 0 (
		COPY /Y installSiebel.bat %SIEBEL_DIR%\installSiebel.bat
		COPY /Y rreg.exe %SIEBEL_DIR%\rreg.exe
		@echo installSiebel.bat %PROD_INSTALL% > %SIEBEL_DIR%\rerun_installSiebel.bat
	)
	@SET ERR_CODE=0
	@GOTO :EOF


:EXIT_SUCCESS
	e@cho "-------------------------  Install Status --------------------------- "
	e@cho "%0 completed successfully."
	@GOTO	:LAST

:EXIT_WARNING
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 Completed with Warning(s)"
	@GOTO	:LAST


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: EXIT_ERROR
:: We never want to exit with non-0 error status.  Doing so would
:: abort the entire installation.  Not what we want.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:EXIT_ERROR
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 failed  with Error : %result%"
	EXIT	0

:LAST
	@echo "--------------------------------------------------------------------- "
