REM 2005 (c) Copyright IBM Corp.
REM All Rights Reserved.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 				  2005 (c) Copyright IBM Corp
:: 					All Rights Reserved
::   
:: OVERVIEW:
::   
:: Note this exact same script is included as the install.bat for
:: install proxy and uninstall.bat for the uninstall proxy.
::
:: USAGE  script <parent dir for FunctionalTester> ["INSTALL" | "UNINSTALL"]
:: 
:: AUTHOR:  Christopher Maguire
::   
:: DATE			COMMENT
:: 2005.10.03	Initial version of script.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

CALL :ECHO_OFF
CALL :LogHeader Start %0
CALL :SetGlobals %0 %1 %2
@if %ACTION% == "UNINSTALL" (
	cd ..
)
CALL :Main
CALL :LogHeader End %0
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: This script is copied to the uninstall proxy's uninstall.bat.
:: When run as uninstall.bat, it is NOT run from the uninstall proxy.
:: To determine if we're being run as install.bat or uninstall.bat we look where we are.
:: If we're uninstalling, 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetGlobals
	SET ACTION=%3
	SET PROD_INSTALL=%2
	SET RFTPlugins=%PROD_INSTALL%\FunctionalTester\eclipse\plugins
	SET WSW=%RFTPlugins%\com.rational.test.ft.wswplugin_6.1.0
	SET ERR_CODE=0
	SET result=""
	@GOTO :EOF

:Main
	CALL :CheckGacUtility
																		@if not %ERR_CODE% == 0 GOTO :EOF
	CALL :GacWithPolicyFile %WSW% rtxftnet.dll policy.6.1.rtxftnet.dll
																		@if not %ERR_CODE% == 0 GOTO :EOF
	CALL :ChangePermissions
																	@if not %ERR_CODE% == 0 GOTO :EOF
	@REM CALL :CopyConfiguration %PROD_INSTALL%
																	@if not %ERR_CODE% == 0 GOTO :EOF
	CALL :SetRSDPKey
																	@if not %ERR_CODE% == 0 GOTO :EOF
	CALL :InstallSiebel
																	@if not %ERR_CODE% == 0 GOTO :EOF
	@REM SET VSNET_2005_Present=0
	@REM CALL :CheckForVSNet 8.0
	@REM CALL :CorrectConfigLocation
		
	@GOTO :EOF

:ECHO_ON
	@ECHO ON
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 ECHO OFF (but for now, let's just leave it on all the time)
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ECHO_OFF
	@ECHO ON
	@GOTO :EOF

:LogHeader
	@echo "---------------- %1 %2 -----------------"
	Date /T
	Time /T
	@echo "Current Directory:"
	cd
	@GOTO	:EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 			           Check GacUtility
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckGacUtility
	CALL :CheckFileExistance gacutility.exe
	@if %ERR_CODE%==1 (
		SET result=Gacutility not found
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                     Run GAC Utility with Policy file
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:GacWithPolicyFile
	@SET	ERR_CODE=0
	CALL :CheckFileExistance %1\%2
	@IF %ERR_CODE%==1 GOTO :EOF
	CALL :CheckFileExistance %1\%3
	@IF %ERR_CODE%==1 GOTO :EOF

	@CALL :ECHO_ON
	gacutility.exe -a %1\%2 -p %1\%3 -o
	@IF %ERRORLEVEL% == 0 ( 
		@CALL :ECHO_OFF
		@echo "GACUtility.exe succeeded"
		@GOTO :EOF
	) else (
		@CALL :ECHO_OFF
		SET ERR_CODE=1
		@echo "GACUtility.exe Error"
	)
	@GOTO :EOF 

:ChangePermissions
	chperm "%ALLUSERSPROFILE%\Application Data\IBM\RFT" /T /G Everyone:C /Y
	@GOTO :EOF

:CopyConfiguration
	@if not EXIST %1\FTSamples\ClassicsJavaA.jar (
		copy /Y config\IBM\RFT\configuration\configurations.rftcfg	"%ALLUSERSPROFILE%\Application Data\IBM\RFT\configuration\configurations.rftcfg"
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Check if VS Net exists
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckForVSNet
	@set ver=%1
	@set KEY=HKLM\SOFTWARE\Microsoft\VisualStudio\%ver%
	@set VALUE=InstallDir
    @set REG_QUERY=rreg.exe query %KEY%
    @set errorlevel=
    @%REG_QUERY% /v %VALUE%
    @if errorlevel 1 (
		@GOTO :EOF
	)
    @set dir=
    @for /f "tokens=2*" %%i in ('%REG_QUERY% /v %VALUE%') do @set dir=%%j
    @if "%dir%" == "" (
		@GOTO :EOF
	)
	@CALL :CheckFileExistance "%dir%devenv.exe"
	@if not %ERR_CODE% == 0 (
		@GOTO :EOF
	)
	@if %ver% == 7.1 (
		SET VSNET_2003_Present=1
	)
	@if %ver% == 8.0 (
		SET VSNET_2005_Present=1
	)
    @GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Config files should only be in wsw plugin's top folder if VS Net 2005 is installed
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CorrectConfigLocation
    pushd ..\eclipse\plugins\com.rational.test.ft.wswplugin_6.1.0
    @IF not EXIST configs (
        mkdir configs
		copy /Y rational_ft.exe.config  configs\rational_ft.exe.config
		copy /Y rational_ftw.exe.config configs\rational_ftw.exe.config
    )
	@if %VSNET_2005_Present% == 0 (
		@ECHO --- VS Net 2005 NOT installed.
		@ECHO --- Hiding config files if necessary...
		CALL :DelIfFromExists rational_ft.exe.config
		CALL :DelIfFromExists rational_ftw.exe.config
		@ECHO --- Done hiding config files.
	) else (
		@ECHO --- VS Net 2005 installed.
		@ECHO --- Unhiding config files if necessary...
		copy /Y configs\rational_ft.exe.config  rational_ft.exe.config
		copy /Y configs\rational_ftw.exe.config rational_ftw.exe.config
		@ECHO --- Done unhiding config files.
	)
    popd
	@GOTO :EOF

:DelIfFromExists
	@SET from=%1
	@if EXIST %from% (
		del /Q /F %from%
	) else (
		@ECHO No need to hide %from%
	)
	GOTO :EOF



::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Set Rational Software Development Platform Key
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:SetRSDPKey
	@set KEY="HKLM\SOFTWARE\IBM\Rational\Software Development Platform\products\com.ibm.rational.functional tester"
	rreg.exe add %KEY% /v location /t REG_SZ /d %PROD_INSTALL%
	rreg.exe add %KEY% /v name     /t REG_SZ /d "IBM Rational Functional Tester"
	rreg.exe add %KEY% /v version  /t REG_SZ /d 6.1
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 						 Install Siebel
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:InstallSiebel
	CALL installSiebel.bat %PROD_INSTALL% INSTALL
	@GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::                                         Check For a file existance
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:CheckFileExistance
	@SET	ERR_CODE=0
	@IF  EXIST %1 (
		SET result=File Exists
	)else (
		SET result=File Not Found
		SET	ERR_CODE=1
	)
	@echo "Searching for file %1....%result%"
	@GOTO :EOF 

:EXIT_SUCCESS
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 completed successfully."
	@GOTO	:LAST

:EXIT_WARNING
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 Completed with Warning(s)"
	@GOTO	:LAST


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: EXIT_ERROR
:: We never want to exit with non-0 error status.  Doing so would
:: abort the entire installation.  Not what we want.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:EXIT_ERROR
	@echo "-------------------------  Install Status --------------------------- "
	@echo "%0 failed  with Error : %result%"
	EXIT	0

:LAST
	@echo "--------------------------------------------------------------------- "
